Graphics3D 800, 600, 32,2
SetBuffer BackBuffer()

Dim LAND_BRUSHES(40)
Dim FEATURE_BRUSHES(10)

For i = 0 To 9
	LAND_BRUSHES(0 + (i*4)) = LoadBrush("tiles/grass.png", 1)
	LAND_BRUSHES(1 + (i*4)) = LoadBrush("tiles/desert.png", 1)
	LAND_BRUSHES(2 + (i*4)) = LoadBrush("tiles/stone.png", 1)
	LAND_BRUSHES(3 + (i*4)) = LoadBrush("tiles/water.png", 1)
Next

FEATURE_BRUSHES(1) = LoadBrush("tiles/tree1.png", 3)
FEATURE_BRUSHES(2) = LoadBrush("tiles/tree2.png", 3)
FEATURE_BRUSHES(3) = LoadBrush("tiles/tree3.png", 3)
FEATURE_BRUSHES(4) = LoadBrush("tiles/mountain.png", 3)
FEATURE_BRUSHES(5) = LoadBrush("tiles/rocks.png", 3)

Global rval

AmbientLight 255,255,255

worldX = 512
worldY = 256

Const lbrushes = 25
Const fbrushes = 5

Dim LAND_SURFACE(0)
Dim FEATURE_SURFACE(0)

Dim TILE_MAP(worldX-1, worldY-1, 2)
Dim SHADOW_MAP(0, 0)
Dim mapsurface(brushes-1)

For x = 0 To worldX - 1
	For y = 0 To worldY - 1
		TILE_MAP(x, y, 0) = Rand(0, lbrushes-1)	; land map
		ftmp = Rand(-20, 5)
		If ftmp <0 Then ftmp = 0
		TILE_MAP(x, y, 1) = ftmp	; feature map
		TILE_MAP(x, y, 2) = True	; occlusion map
	Next
Next

mapmesh = MAP_GenerateMesh(brushes, worldx, worldy, lbrushes, fbrushes)

cam = CreateCamera()

PositionEntity cam, 0, 0, -5

dummy = CreatePivot()
PointEntity cam, dummy
FreeEntity dummy

While Not KeyHit(1)

	If KeyDown(203) Then MoveEntity cam, -0.1, 0, 0
	If KeyDown(205) Then MoveEntity cam, 0.1, 0, 0
	If KeyDown(200) Then MoveEntity cam, 0, 0.1, 0
	If KeyDown(208) Then MoveEntity cam, 0, -0.1, 0
	
	If KeyDown(51) Then TurnEntity cam, 0, 0, -0.5
	If KeyDown(52) Then TurnEntity cam, 0, 0, 0.5
	
	If KeyDown(78) Then MoveEntity cam, 0, 0, 0.2
	If KeyDown(74) Then MoveEntity cam, 0, 0, -0.2
	
	If KeyHit(57) Then wf=1-wf : WireFrame wf
	
	RenderWorld
	
	Text 0, 0, EntityX(cam) + " / " + EntityY(cam) + " / " + EntityZ(cam)
	
	Text 0, 10, "TILE X: " + Floor(EntityX(cam)) + " / TILE Y: " + (Floor(EntityY(cam)) * -1)
	
	Text 0,20,CountSurfaces(rval)
	
	Flip 0

Wend

End





Function MAP_GenerateMesh(Tiles%, worldX%, worldY%, LTiles%, FTiles%)

	rval = CreateMesh()
	Dim LAND_SURFACE(LTiles-1)
	Dim FEATURE_SURFACE(FTiles)
	
	For i = 0 To (LTiles - 1)
		LAND_SURFACE(i) = CreateSurface(rval)
		PaintSurface LAND_SURFACE(i), LAND_BRUSHES(i)
	Next
	
	For i = 1 To FTiles
		FEATURE_SURFACE(i) = CreateSurface(rval)
		PaintSurface FEATURE_SURFACE(i), FEATURE_BRUSHES(i)
	Next
	
	For x = 0 To (worldX - 1)
		For y = 0 To (-1 * (worldY - 1)) Step -1
			lbrush = TILE_MAP(x, (-1 * y), 0)
			fbrush = TILE_MAP(x, (-1 * y), 1)
			V1 = AddVertex(LAND_SURFACE(lbrush), x, y, 0, 0, 1)
			V2 = AddVertex(LAND_SURFACE(lbrush), x+1, y, 0, 1, 1) 
			V3 = AddVertex(LAND_SURFACE(lbrush), x, y+1, 0, 0, 0) 
			V4 = AddVertex(LAND_SURFACE(lbrush), x+1, y+1, 0, 1, 0)
			AddTriangle(LAND_SURFACE(lbrush), V1, V4, V2)
			AddTriangle(LAND_SURFACE(lbrush), V1, V3, V4)
			
			If fbrush <> 0
				V1 = AddVertex(FEATURE_SURFACE(fbrush), x, y, -0.01, 0, 1)
				V2 = AddVertex(FEATURE_SURFACE(fbrush), x+1, y, -0.01, 1, 1) 
				V3 = AddVertex(FEATURE_SURFACE(fbrush), x, y+1, -0.01, 0, 0) 
				V4 = AddVertex(FEATURE_SURFACE(fbrush), x+1, y+1, -0.01, 1, 0)
				AddTriangle(FEATURE_SURFACE(fbrush), V1, V4, V2)
				AddTriangle(FEATURE_SURFACE(fbrush), V1, V3, V4)
			EndIf
		Next
	Next
	
	UpdateNormals rval
	
	Return rval
	
End Function



;~IDEal Editor Parameters:
;~C#Blitz3D